			// , 믮 ࠫ쭮  讬 ᫥ ⥩
__global__ void sumKernel ( float * a, float * b, float * c )
{
			//   
	int idx = threadIdx.x + blockIdx.x * blockDim.x;
	
			// 믮 ࠡ ᮮ⢥   
	c [idx] = a [idx] + b [idx];
}

void sum ( float * a, float * b, float * c, int n )

{
    int     numBytes = n * sizeof ( float );
    float * aDev = NULL;
    float * bDev = NULL;
    float * cDev = NULL;
    
			// 뤥   GPU
    cudaMalloc ( (void**)&aDev, numBytes );
    cudaMalloc ( (void**)&bDev, numBytes );
    cudaMalloc ( (void**)&cDev, numBytes );

                    //  䨣 ᪠ n ⥩
    dim3 threads = dim3(512, 1);
    dim3 blocks  = dim3(n / threads.x, 1);

                    // ᪮஢ 室    CPU   GPU
    cudaMemcpy      ( aDev, a, numBytes, cudaMemcpyHostToDevice );
    cudaMemcpy      ( bDev, b, numBytes, cudaMemcpyHostToDevice );
    
			// 맢    䨣樥  ࠡ⪨ 
    sumKernel<<<blocks, threads>>> (aDev, bDev, cDev);
    
			// ᪮஢ १   CPU
    cudaMemcpy ( c, cDev, numBytes, cudaMemcpyDeviceToHost );

			// ᢮ 뤥  GPU
    cudaFree   ( aDev );
    cudaFree   ( bDev );
    cudaFree   ( cDev );
}
